import GTpiles as pl

p = pl.Pile([1,2,3,4,2,1,3])

p.isVoid()

def dup(p):
    if p.getHeight()>0:
        x = p.getTop()
        p.push(x)
    return None
    
def swap(p):
    if p.getHeight()>1:
        x = p.pop()
        y = p.pop()
        p.push(x)
        p.push(y)
    return None
    
def n_ieme_element(p, n):
    if (n<p.getHeight()): # s'il y a au moins n éléments dans la pile p
        q = pl.Pile([])
        # on dépile les n éléments au sommet de p 
        # pour les empiler dans une pile q
        for i in range(n):
            q.push(p.pop())
        print(p.str())
        print(q.str())
        # on récupère la valeur qui apparaît alors au sommet de p
        x = p.getTop()
        # on empile les éléments de q dans la pile p
        for i in range(n):
            p.push(q.pop())
        return x
    else:
        return None
        
def permuter(p):
    s = p.pop()
    q = pl.Pile([])
    while (p.getHeight()>0):
        q.push(p.pop())
    p.push(s)
    while (q.getHeight()>0):
        p.push(q.pop())
    return None

def choix():
    from random import randint
    return randint(0,1)
        
def battage(p, q):
    r = pl.Pile([])
    # Tant qu'aucune pile n'est vide,
    while ((p.getHeight()>0) and (q.getHeight()>0)):
        # on en choisit une au hasard pour dépiler.
        if choix():
            r.push(p.pop())
        else:
            r.push(q.pop())
    # L'une des deux piles est maintenant vide. 
    # On vide la pile p (si ce n'est pas déjà fait). 
    while (p.getHeight()>0):
        r.push(p.pop())
    # On vide la pile q (si ce n'est pas déjà fait). 
    while (q.getHeight()>0):
        r.push(q.pop())
    # On remet les valeurs à l'endroit
    R = pl.Pile([])
    while not(r.isVoid()):
        R.push(r.pop())
    return R

p = pl.Pile(['a1','a2','a3','a4','a5'])
q = pl.Pile(["b1",'b2','b3','b4','b5'])

def fusion(p,q):
    r = pl.Pile([])
    while ((p.getHeight()>0) and (q.getHeight()>0)):
    # on choisit la plus grande valeur pour dépiler.
        if (p.getTop()>q.getTop()):
            r.push(p.pop())
        else:
            r.push(q.pop())
    # L'une des deux piles est maintenant vide. 
    # On vide l'autre pile ! 
    while (p.getHeight()>0):
        r.push(p.pop())
    while (q.getHeight()>0):
        r.push(q.pop())
    # On remet les valeurs à l'endroit
    R = pl.Pile([])
    while not(r.isVoid()):
        R.push(r.pop())
    return R
    
p = pl.Pile([1,2,5,8,17,23,26])
q = pl.Pile([2,3,6,8,12,16,21,23,25])

def bienParenthesee(expr):
    p = pl.Pile([])
    for x in expr:
        if (x=='('):
            p.push(x)
        if (x==')'):
            if (p.isVoid()):
                return False # Plus de parenthèses fermées que de parenthèses ouvertes ! 
            else:
                p.pop()
    # On vérifie qu'on a bien fermé toutes les parenthèses ouvertes. 
    return (p.isVoid())

expr = "(bonjour les (petits) amis (c'est moi, (Bozo (le clown)))!)"

def npi(args):
    p = pl.Pile([])
    for x in args:
        if (x in ['+','-','*','/']):
        # On dépile deux éléments pour effectuer une opération binaire
            a = p.pop() # dernier opérande saisi
            b = p.pop() # avant-dernier opérande saisi
            if (x=='+'):
                p.push(b+a)
            if (x=='*'):
                p.push(b*a)
            if (x=='-'):
                p.push(b-a)
            if (x=='/'):
                p.push(b/a)
        else: # On empile un opérande supplémentaire
            p.push(x)
    return p.pop()
    
npi([5,2,7,-10,'-','*','/'])